summaryrefslogtreecommitdiff
path: root/tools
diff options
context:
space:
mode:
authorTony Breeds <tony@bakeyournoodle.com>2016-11-08 14:15:10 +1100
committerTony Breeds <tony@bakeyournoodle.com>2016-11-23 20:32:32 +1100
commit78f113780510b741bc974c69eb9b0718cd657c1d (patch)
treeb657941010e4c297d871032f7a7fd04d0976c85e /tools
parent1346a5e8308072517f1dea8e4e59a56142300e23 (diff)
downloadoslo-messaging-78f113780510b741bc974c69eb9b0718cd657c1d.tar.gz
Add Constraints support
Adding constraints support to libraries is slightly more complex than services as the libraries themselves are listed in upper-constraints.txt which leads to errors that you can't install a specific version and a constrained version. This change adds constraints support by also adding a helper script to edit the constraints to remove oslo.messaging. Change-Id: I8be883215f27abb58d15b85e8542cbdf32000bac
Diffstat (limited to 'tools')
-rwxr-xr-xtools/tox_install.sh30
1 files changed, 30 insertions, 0 deletions
diff --git a/tools/tox_install.sh b/tools/tox_install.sh
new file mode 100755
index 0000000..43468e4
--- /dev/null
+++ b/tools/tox_install.sh
@@ -0,0 +1,30 @@
+#!/usr/bin/env bash
+
+# Client constraint file contains this client version pin that is in conflict
+# with installing the client from source. We should remove the version pin in
+# the constraints file before applying it for from-source installation.
+
+CONSTRAINTS_FILE=$1
+shift 1
+
+set -e
+
+# NOTE(tonyb): Place this in the tox enviroment's log dir so it will get
+# published to logs.openstack.org for easy debugging.
+localfile="$VIRTUAL_ENV/log/upper-constraints.txt"
+
+if [[ $CONSTRAINTS_FILE != http* ]]; then
+ CONSTRAINTS_FILE=file://$CONSTRAINTS_FILE
+fi
+# NOTE(tonyb): need to add curl to bindep.txt if the project supports bindep
+curl $CONSTRAINTS_FILE --insecure --progress-bar --output $localfile
+
+pip install -c$localfile openstack-requirements
+
+# This is the main purpose of the script: Allow local installation of
+# the current repo. It is listed in constraints file and thus any
+# install will be constrained and we need to unconstrain it.
+edit-constraints $localfile -- $CLIENT_NAME
+
+pip install -c$localfile -U $*
+exit $?